#
#
# $Id: indimail-mta.spec.in,v 1.289 2020-11-25 19:45:36+05:30 Cprogrammer Exp mbhangui $
%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%else
%define _project           local
%global build_on_obs       0
%global _hardened_build    1
%endif

%if %{defined nodebug}
%global debug_package      %{nil}
%endif

%global qmaildir           /var/indimail
%global _prefix            /usr
%global libexecdir         /usr/libexec/indimail
%global shareddir          /usr/share/indimail
%global mandir             /usr/share/man
%global qsysconfdir        /etc/indimail
%global logdir             /var/log/svc
%global servicedir         /service
%global plugindir          %{_prefix}/lib/indimail/plugins
%global tcpserver_plugin   1
%global see_base           For a description of IndiMail visit https://github.com/mbhangui/indimail-mta
%global nodksignatures     0
%global notlsarr           0

%global qcount             5
%global qbase              %{qmaildir}/queue
%global dkimkeyfn          default

%if %build_on_obs == 1
%global packager Manvendra Bhangui <indimail-mta@indimail.org>
%endif

%if 0%{?suse_version}
%global dist suse
%global disttag suse
%endif

%if 0%{?fedora_version}
%global dist %{?dist}
%global disttag fedora
%endif

Summary: A Flexible SMTP server
Name: indimail-mta
Version: 2.12
Release: 1.1%{?dist}

## user/group management
# Note: it is not necessary to assign 555 for uid, gid. The package will use any id assigned to username, groupname
# at runtime
%global uid                555
%global gid                555
%global username           indimail
%global groupname          indimail
# Note: 999 indimail-mta does not require any specific values for uids/gids. 999 is just
# for rpmlint to shut up and stop complaining
Provides: user(%username)   = %uid
Provides: user(alias)       > 999
Provides: user(qmaild)      > 999
Provides: user(qmailp)      > 999
Provides: user(qmailq)      > 999
Provides: user(qmailr)      > 999
Provides: user(qmails)      > 999
Provides: user(qscand)      > 999
Provides: group(%groupname) = %gid
Provides: group(qmail)      > 999
Provides: group(qscand)     > 999
%if %build_on_obs == 0
Requires(pre): shadow-utils
Requires(postun): shadow-utils
%endif

%if %build_on_obs == 1
License: GPL-3.0+
%else
License: GPLv3
%endif
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Base
%else
Group: Productivity/Networking/Email/Servers
%endif
Source0: http://downloads.sourceforge.net/indimail/%{name}-%{version}.tar.gz
Source1: http://downloads.sourceforge.net/indimail/%{name}-rpmlintrc

%if 0%{?suse_version} >= 1120
Source2: http://downloads.sourceforge.net/indimail/%{name}-permissions.easy
Source3: http://downloads.sourceforge.net/indimail/%{name}-permissions.secure
Source4: http://downloads.sourceforge.net/indimail/%{name}-permissions.paranoid
%endif

URL: https://github.com/mbhangui/indimail-mta
AutoReq: Yes
Conflicts: indimail-mini
Conflicts: indimail < 2.5
Conflicts: indimail-mta < 2.0
Obsoletes: indimail-mta < 2.0
BuildRequires: gcc gcc-c++ make autoconf automake libtool pkgconfig
BuildRequires: sed findutils diffutils gzip coreutils grep
BuildRequires: glibc glibc-devel binutils
BuildRequires: openssl openssl-devel mysql-devel
BuildRequires: libqmail-devel libdkim-devel libsrs2-devel

##################################### OBS ####################################
%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks
#!BuildIgnore: post-build-checks
%endif
%endif
##############################################################################

%if 0%{?suse_version}
BuildRequires: openldap2-devel
%else
BuildRequires: openldap-devel
%endif

%if 0%{?suse_version} >= 1120
PreReq: permissions
%endif

Requires: /usr/sbin/useradd /usr/sbin/userdel /usr/sbin/groupadd /usr/sbin/groupdel
Requires: /sbin/chkconfig procps /usr/bin/awk /usr/bin/which
Requires: coreutils grep /bin/sh glibc openssl
Requires: diffutils sed findutils pkgconfig
%if %{undefined suse_version} && %{undefined sles_version}
Requires: /usr/bin /usr/sbin
%endif

%if 0%{?fedora_version} > 30 || 0%{?centos_version} > 700 || 0%{?rhel_version} > 700 || 0%{?centos_ver} > 7
Requires: policycoreutils
%else
%if %{defined centos_version} || %{defined rhel_version}
Requires: policycoreutils-python
%endif
%endif

%if 0%{?suse_version}
Requires: insserv-compat
%else
Requires: initscripts
%endif
Requires: daemontools >= 1.0
Requires: ucspi-tcp >= 1.0
#
%if %build_on_obs == 1
BuildRoot: %{_tmppath}/%{name}-%{version}-build
%endif
#
# IndiMail is choosy and runs on reliable OS only
#
Excludeos: windows

%description
indimail-mta provides a standalone mta server that is part of the IndiMail
messaging platform. It comprises of the following packages

qmail,
serialmail,
qmailanalog,
dotforward,
fastforward,
mess822,
daemontools,
ucspi-tcp,

The package combines qmail with other packages qmail, daemontools,
ucspi-tcp, serialmail, qmailanalog, fastforward, mess822

Original Author: Dan J. Bernstein <djb@cr.yp.to>

%{see_base}

%package -n indimail-mini
Summary: IndiMail - Mini Client Installation
Group: Productivity/Networking/Email/Clients
Conflicts: %{name}
Conflicts: indimail-mini < 2.0
%if 0%{?suse_version} >= 1120
PreReq: permissions
%endif
Requires: coreutils /bin/sh glibc openssl
%if %{undefined suse_version} && %{undefined sles_version}
Requires: /usr/bin /usr/sbin
%endif

%description -n indimail-mini
This package contains sendmail, qmail-inject and qmail-qmqpc - Bare minimum
programs to have a mini-indimail installation.

A mini-indimail installation doesn't have a mail queue. It gives each
new message to a central server using QMQP.

%{see_base}

%prep
%setup -q

%build
(
echo "---------------- INFORMATION ------------------------"
echo target        %_target
echo target_alias  %_target_alias
echo target_cpu    %_target_cpu
echo target_os     %_target_os
echo target_vendor %_target_vendor
echo Building %{name}-%{version}-%{release} Build %{_build} OS %{_os} Dist %dist disttag %disttag libs %{_lib} %{_libdir}
echo "------------------------------------------------------"
) > %{name}-rpm.info

(
echo "NAME=%{name}"
echo "Description=\"IndiMail MTA\""
echo "MTA_version="%{version}""
echo "ID=%{name}"
echo "HOME_URL=\"https://github.com/mbhangui/indimail-mta\""
echo "PACKAGE_BUGREPORT=\"Manvendra Bhangui indimail-mta@indimail.org\""
) > %{name}-release

#### qmail ######################
%{__sed} 's{PREFIX{%{_prefix}{'         conf-prefix.in     > conf-prefix
%{__sed} 's{QMAIL{%{qmaildir}{'         conf-qmail.in      > conf-qmail
%{__sed} 's{SYSCONFDIR{%{qsysconfdir}{' conf-sysconfdir.in > conf-sysconfdir
%{__sed} 's{SHAREDDIR{%{shareddir}{'    conf-shared.in     > conf-shared
%{__sed} 's{LIBEXECDIR{%{libexecdir}{'  conf-libexec.in    > conf-libexec
%{__sed} 's{SERVICEDIR{%{servicedir}{'  conf-servicedir.in > conf-servicedir
%if %notlsarr == 0
  echo "-DHASTLSA" > conf-tlsa
%else
  > conf-tlsa
%endif
%if %{tcpserver_plugin} == 1
  echo "-DLOAD_SHARED_OBJECTS" > conf-dlopen
%else
  %{__rm} -f conf-dlopen
%endif
# create conf-users
(
echo "alias"
echo "qmaild"
echo "qmaill"
echo "root"
echo "qmailp"
echo "qmailq"
echo "qmailr"
echo "qmails"
echo %username
echo "qscand"
echo
echo "The qmail system is heavily partitioned for security; it does almost"
echo "nothing as root."
echo
echo "The first nine lines of this file are the alias user, the daemon user,"
echo "the log user, the owner of miscellaneous files such as binaries, the"
echo "passwd user, the queue user, the remote user, the send user, the"
echo "indimail user and the virus scan user."
) > /tmp/conf-users
diff /tmp/conf-users conf-users > /dev/null 2>&1
if [ $? -ne 0 ] ; then
  %{__mv} /tmp/conf-users conf-users
else
  %{__rm} -f /tmp/conf-users
fi
# create conf-groups
(
echo "qmail"
echo "nofiles"
echo %groupname
echo "qscand"
echo
echo "These are the qmail groups. The second group should not have access to"
echo "any files, but it must be usable for processes; this requirement"
echo "excludes the \`\`nogroup'' and \`\`nobody'' groups on many systems."
) > /tmp/conf-groups
diff /tmp/conf-groups conf-groups > /dev/null 2>&1
if [ $? -ne 0 ] ; then
  %{__mv} /tmp/conf-groups conf-groups
else
  %{__rm} -f /tmp/conf-groups
fi
./catChangeLog doc/ChangeLog > ChangeLog-indimail-mta
echo %{__cc} -g %{optflags} -Wall -O2 -Wimplicit -fPIC -fno-strict-aliasing -Wunused -Wcomment -Wchar-subscripts -Wuninitialized -Wshadow -Wcast-align -Wwrite-strings -Wno-discarded-qualifiers -I/usr/include/qmail > conf-cc
%if %{defined nodebug}
  echo %{__cc} -O2 -fPIE -pie -s > conf-ld
%else
  echo %{__cc} -O2 -fPIE -pie    > conf-ld
%endif

%install
%{__mkdir_p} %{buildroot}%{_prefix}

# rpm macros are complicated. Read https://rpm.org/user_doc/macros.html
%if 0%{?build_cflags:1}
  CFLAGS="%{build_cflags}"
%else
  CFLAGS="%{optflags}"
%endif
%if 0%{?build_ldflags:1}
  LDFLAGS="%{build_ldflags} $LDFLAGS"
%endif
%{__make} SYSTEM=LINUX %{?_smp_mflags} CC="%{__cc}" CFLAGS="$CFLAGS" LDFLAGS="$LDFLAGS"
%{__make} SYSTEM=LINUX %{?_smp_mflags} DESTDIR=%{buildroot} install
%{__mkdir_p} %{buildroot}%{shareddir}/doc
%{__mkdir_p} %{buildroot}%{libexecdir}
%{__mkdir_p} %{buildroot}%{qsysconfdir}
#copy files not copied by setup
install -m 0644 %{name}-release  %{buildroot}%{qsysconfdir}/%{name}-release
install -m 0644 %{name}-rpm.info %{buildroot}%{qsysconfdir}/%{name}-rpm.info
install -m 0644 ChangeLog-indimail-mta %{buildroot}%{shareddir}/doc/ChangeLog-indimail-mta
if [ -f qupgrade.sh ] ; then
  install -m 0755 qupgrade.sh %{buildroot}%{libexecdir}/qupgrade.sh
fi
if [ -f qlocal_upgrade.sh ] ; then
  install -m 0755 qlocal_upgrade.sh %{buildroot}%{libexecdir}/qlocal_upgrade.sh
fi
if [ -f indimail-mta.fc ] ; then
  install -m 0644 indimail-mta.fc %{buildroot}%{qsysconfdir}/indimail-mta.fc
fi
if [ -f indimail-mta.te ] ; then
  install -m 0644 indimail-mta.te %{buildroot}%{qsysconfdir}/indimail-mta.te
fi
/bin/rm -f ChangeLog %{name}-release %{name}-rpm.info

%if 0%{?suse_version} >= 1120
%{__mkdir_p} %{buildroot}%{_sysconfdir}/permissions.d/
  install -m 644 %{S:2} %{buildroot}%{_sysconfdir}/permissions.d/%{name}-permissions
  install -m 644 %{S:3} %{buildroot}%{_sysconfdir}/permissions.d/%{name}-permissions.secure
%endif

# remove devel files as we are not building a devel package
%{__rm} -rf %{buildroot}%{mandir}/man3

# Compress the man pages
find %{buildroot}%{mandir} -type f -exec gzip -q {} \;

# Create these files so that %%ghost does not complain
for i in tcp.smtp tcp.smtp.cdb tcp.qmtp tcp.qmtp.cdb tcp.qmqp \
tcp.qmqp.cdb
do
  if [ ! -f %{buildroot}%{qsysconfdir}/tcp/$i ] ; then
    touch %{buildroot}%{qsysconfdir}/tcp/$i
  fi
done
touch %{buildroot}%{qsysconfdir}/indimail-mta.pp
touch %{buildroot}%{qsysconfdir}/indimail-mta.mod
(
for i in `cat controlfiles.q`
do
  case "$i" in
  signatures)
  echo "%ghost %attr(0644,qscand,qscand) %config(noreplace,missingok) %{qsysconfdir}/control/$i"
  ;;
  spamignore)
  echo "%ghost %attr(0664,root,qmail) %config(noreplace,missingok) %{qsysconfdir}/control/$i"
  ;;
  *)
  echo "%ghost %config(noreplace,missingok) %{qsysconfdir}/control/$i"
  ;;
  esac
  echo $i 1>&3
  touch %{buildroot}%{qsysconfdir}/control/$i
done

for i in rsa2048.pem rsa1024.pem servercert.cnf servercert.pem dh1024.pem \
dh2048.pem dh512.pem rsa512.pem servercert.rand
do
  echo "%ghost %attr(0640,indimail,qmail) %config(noreplace,missingok) %{qsysconfdir}/certs/$i"
  echo ../certs/$i 1>&3
  touch %{buildroot}%{qsysconfdir}/certs/$i
done
echo "%ghost %attr(0644,root,root) %{qsysconfdir}/resolv.conf"
echo ../resolv.conf 1>&3
) > config_files.list 3>%{buildroot}%{qsysconfdir}/controlfiles.q

%if %{undefined suse_version} && %{undefined sles_version}
  %{__mkdir_p} %{buildroot}%{logdir}
  for i in deliver.25 greylist.1999 \
    qmqpd.628 qmtpd.209 qscanq smtpd.25 resolvconf \
    smtpd.366 smtpd.465 smtpd.587 qmail-daned.1998 \
    udplogger.3000
  do
    %{__mkdir_p} %{buildroot}%{logdir}/$i
    touch %{buildroot}%{logdir}/$i/current
  done
%endif

%if %{undefined nodebug}
 /bin/chmod -R 755 %{buildroot}%{_prefix}/bin
 /bin/chmod -R 755 %{buildroot}%{_prefix}/sbin
 /bin/chmod -R 755 %{buildroot}%{libexecdir}
%endif

%files -f config_files.list
%defattr(-, root, root,-)
#
# Directories
#
%dir %attr(555,root,qmail)                         %{qmaildir}
                                                   %{qmaildir}/bin
                                                   %{qmaildir}/sbin
                                                   %{qmaildir}/users
                                                   %{qmaildir}/control
                                                   %{qmaildir}/libexec
# opensuse requres ghost files to be present
%if %{undefined suse_version} && %{undefined sles_version}
%ghost %dir %attr(0755,qmaill,nofiles)             %{logdir}
%ghost %dir %attr(0755,qmaill,nofiles)             %{logdir}/*
%ghost      %attr(-,qmaill,nofiles)                %{logdir}/*/*
%endif
%dir %attr(555,root,root)                          %{libexecdir}
%dir %attr(555,root,root)                          %{libexecdir}/qfilters
%dir %attr(555,root,root)                          %{shareddir}
%dir %attr(555,root,root)                          %{shareddir}/boot
%dir %attr(555,root,root)                          %{shareddir}/doc
%dir %attr(755,root,qmail)                         %{qmaildir}/queue
%dir %attr(750,qscand,qscand)                      %{qmaildir}/qscanq
%dir %attr(750,qscand,qscand)                      %{qmaildir}/qscanq/root
%dir %attr(750,qscand,qscand)                      %{qmaildir}/qscanq/root/scanq
%dir %attr(2775,alias,qmail)                       %{qmaildir}/alias
%dir %attr(2775,indimail,qmail)                    %{qmaildir}/autoturn
%dir %attr(2755,root,qmail)                        %{qsysconfdir}
%dir %attr(2775,indimail,qmail)                    %{qsysconfdir}/users
%dir %attr(2775,indimail,qmail)                    %{qsysconfdir}/certs
%dir %attr(2775,indimail,qmail)                    %{qsysconfdir}/control
%dir %attr(2775,indimail,qmail)                    %{qsysconfdir}/control/cache
%dir %attr(2775,qmailr,qmail)                      %{qsysconfdir}/control/ratelimit
%dir %attr(2755,indimail,qmail)                    %{qsysconfdir}/control/domainkeys
%dir %attr(2775,indimail,qmail)                    %{qsysconfdir}/tcp
%dir %attr(755,indimail,qmail)                     %{qsysconfdir}/control/defaultqueue
%if "%{mandir}" != "/usr/share/man"
%dir %attr(755,root,root)                          %{mandir}
%dir %attr(755,root,root)                          %{mandir}/man1
%dir %attr(755,root,root)                          %{mandir}/man5
%dir %attr(755,root,root)                          %{mandir}/man7
%dir %attr(755,root,root)                          %{mandir}/man8
%endif
%if "%{_prefix}" != "/usr"
%dir %attr(555,root,root)                          %{_libdir}
%endif
%dir %attr(755,root,root)                          %{_prefix}/lib/indimail
%dir %attr(755,root,root)                          %{plugindir}

%attr(444,root,root) %config(noreplace)            %{qsysconfdir}/controlfiles.q

%ghost %config(noreplace,missingok)                %{qsysconfdir}/tcp/tcp.smtp
%ghost %config(noreplace,missingok)                %{qsysconfdir}/tcp/tcp.qmtp
%ghost %config(noreplace,missingok)                %{qsysconfdir}/tcp/tcp.qmqp
#
# These files will get removed during uninstallation
#
%ghost %attr(0644,indimail,indimail)               %{qsysconfdir}/tcp/tcp.smtp.cdb
%ghost %attr(0644,indimail,indimail)               %{qsysconfdir}/tcp/tcp.qmtp.cdb
%ghost %attr(0644,indimail,indimail)               %{qsysconfdir}/tcp/tcp.qmqp.cdb
%ghost %attr(0644,root,root)                       %{qsysconfdir}/indimail-mta.pp
%ghost %attr(0644,root,root)                       %{qsysconfdir}/indimail-mta.mod

%attr(644,root,root)  %config(noreplace)           %{qsysconfdir}/indimail-mta.te
%attr(644,root,root)  %config(noreplace)           %{qsysconfdir}/indimail-mta.fc
%attr(444,root,root)  %config(noreplace)           %{qsysconfdir}/cronlist.q
%attr(644,root,qmail) %config(noreplace)           %{qsysconfdir}/leapsecs.dat
%attr(644,root,qmail) %config(noreplace)           %{qsysconfdir}/leapsecs.txt
%attr(444,root,root)  %config(noreplace)           %{qsysconfdir}/%{name}-release
%attr(444,root,root)  %config(noreplace)           %{qsysconfdir}/%{name}-rpm.info
%attr(644,root,qmail) %config(noreplace,missingok) %{qsysconfdir}/control/nodnscheck
%attr(644,root,qmail) %config(noreplace,missingok) %{qsysconfdir}/control/level2-tlds
%attr(644,root,qmail) %config(noreplace,missingok) %{qsysconfdir}/control/level3-tlds
%attr(644,root,qmail) %config(noreplace,missingok) %{qsysconfdir}/foxhole_all.cdb

%if 0%{?suse_version} >= 1120
%attr(644,root,root)  %config(noreplace,missingok) %{_sysconfdir}/permissions.d/%{name}-permissions
%attr(644,root,root)  %config(noreplace,missingok) %{_sysconfdir}/permissions.d/%{name}-permissions.secure
%endif

#
# Binaries
#
%attr(755,root,root)                    %{_prefix}/bin/queue-fix
%attr(755,root,root)                    %{_prefix}/bin/bouncesaying
%attr(755,root,root)                    %{_prefix}/bin/checkaddr
%attr(755,root,root)                    %{_prefix}/bin/autoresponder
%attr(755,root,root)                    %{_prefix}/bin/822headerfilter
%attr(755,root,root)                    %{_prefix}/bin/checkdomain
%attr(755,root,root)                    %{_prefix}/bin/printmaillist
%attr(755,root,root)                    %{_prefix}/bin/newinclude
%attr(755,root,root)                    %{_prefix}/bin/uacl
%attr(755,root,root)                    %{_prefix}/bin/822print
%attr(755,root,root)                    %{_prefix}/bin/sendmail
%attr(755,root,root)                    %{_prefix}/bin/irmail
%attr(755,root,root)                    %{_prefix}/bin/ifaddr
%attr(755,root,root)                    %{_prefix}/bin/setforward
%attr(755,root,root)                    %{_prefix}/bin/822date
%attr(755,root,root)                    %{_prefix}/bin/iftocc
%attr(755,root,root)                    %{_prefix}/bin/serialqmtp
%attr(755,root,root)                    %{_prefix}/bin/setmaillist
%attr(755,root,root)                    %{_prefix}/bin/qmail-showctl
%attr(755,root,root)                    %{_prefix}/bin/822headerok
%attr(755,root,root)                    %{_prefix}/bin/printforward
%attr(755,root,root)                    %{_prefix}/bin/preline
%attr(755,root,root)                    %{_prefix}/bin/822addr
%attr(755,root,root)                    %{_prefix}/bin/822fields
%attr(755,root,root)                    %{_prefix}/bin/ofmipname
%attr(755,root,root)                    %{_prefix}/bin/822bodyfilter
%attr(755,root,root)                    %{_prefix}/bin/serialsmtp
%attr(755,root,root)                    %{_prefix}/bin/predate
%attr(755,root,root)                    %{_prefix}/bin/condredirect
%attr(755,root,root)                    %{_prefix}/bin/fastforward
%attr(755,root,root)                    %{_prefix}/bin/inewaliases
%attr(755,root,root)                    %{_prefix}/bin/qmail-rm
%attr(755,root,root)                    %{_prefix}/bin/dot-forward
%attr(755,root,root)                    %{_prefix}/bin/datemail
%attr(755,root,root)                    %{_prefix}/bin/qbase64
%attr(755,root,root)                    %{_prefix}/bin/swaks
%attr(755,root,root)                    %{_prefix}/bin/replier
%attr(755,root,root)                    %{_prefix}/bin/822header
%attr(755,root,root)                    %{_prefix}/bin/maildirwatch
%attr(755,root,root)                    %{_prefix}/bin/maildirqmtp
%attr(755,root,root)                    %{_prefix}/bin/maildirdeliver
%attr(755,root,root)                    %{_prefix}/bin/mbox2maildir
%attr(755,root,root)                    %{_prefix}/bin/qmaildirmake
%attr(755,root,root)                    %{_prefix}/bin/maildir2mbox
%attr(755,root,root)                    %{_prefix}/bin/condtomaildir
%attr(755,root,root)                    %{_prefix}/bin/maildirsmtp
%attr(755,root,root)                    %{_prefix}/bin/maildirserial
%attr(755,root,root)                    %{_prefix}/bin/maildircmd
%attr(755,root,root)                    %{_prefix}/bin/maildirsize
%attr(755,root,root)                    %{_prefix}/bin/qarf
%attr(755,root,root)                    %{_prefix}/bin/qaes
%attr(755,root,root)                    %{_prefix}/bin/qnotify
%attr(755,root,root)                    %{_prefix}/bin/rrt
%attr(755,root,root)                    %{_prefix}/bin/drate
%attr(755,root,root)                    %{_prefix}/bin/cidr
%attr(755,root,root)                    %{_prefix}/bin/tcp-env
%attr(755,root,root)                    %{_prefix}/bin/rrforward
%attr(755,root,root)                    %{_prefix}/bin/dk-filter
%attr(755,root,root)                    %{_prefix}/bin/mailsubj
%attr(755,root,root)                    %{_prefix}/bin/822field
%attr(755,root,root)                    %{_prefix}/bin/qmail-cat
%attr(755,root,root)                    %{_prefix}/bin/replier-config
%attr(755,root,root)                    %{_prefix}/bin/forward
%attr(755,root,root)                    %{_prefix}/bin/new-inject
%attr(755,root,root)                    %{_prefix}/bin/filterto
%attr(755,root,root)                    %{_prefix}/bin/822body
%attr(755,root,root)                    %{_prefix}/bin/dktest
%attr(755,root,root)                    %{_prefix}/bin/iftoccfrom
%attr(755,root,root)                    %{_prefix}/bin/qreceipt
%attr(755,root,root)                    %{_prefix}/bin/except
%attr(755,root,root)                    %{_prefix}/bin/dknewkey
%attr(755,root,root)                    %{_prefix}/bin/qmail-inject
%attr(755,root,root)                    %{_prefix}/bin/serialcmd
%attr(755,root,root)                    %{_prefix}/bin/qmail-qread
%attr(755,root,root)                    %{_prefix}/bin/822received
%attr(755,root,root)                    %{_prefix}/bin/qmail-qfilter
%attr(755,root,root)                    %{_prefix}/bin/spfquery
%attr(755,root,root)                    %{_prefix}/bin/srsfilter
%attr(755,root,root)                    %{_prefix}/bin/inotify
%attr(0755,root,root)                   %{_prefix}/bin/udpclient
%attr(0755,root,root)                   %{_prefix}/bin/sslerator
%if %notlsarr == 0
%attr(755,root,root)                    %{_prefix}/bin/qdane
%endif

%attr(755,root,root)                    %{_prefix}/sbin/udplogger
%attr(751,root,root)                    %{_prefix}/sbin/greydaemon
%attr(751,root,root)                    %{_prefix}/sbin/qmail-greyd
%if %notlsarr == 0
%attr(751,root,root)                    %{_prefix}/sbin/qmail-daned
%endif

%attr(755,root,root)                    %{_prefix}/sbin/qmail-popbull
%attr(755,root,root)                    %{_prefix}/sbin/qmail-poppass
%attr(751,root,root)                    %{_prefix}/sbin/ofmipd
%attr(755,root,root)                    %{_prefix}/sbin/qmail-dkim
%attr(755,root,root)                    %{_prefix}/sbin/qmail-dk
%attr(755,root,root)                    %{_prefix}/sbin/spawn-filter
%attr(755,root,root)                    %{_prefix}/sbin/qmail-getpw
%attr(755,root,root)                    %{_prefix}/sbin/qmail-local
%attr(755,root,root)                    %{_prefix}/sbin/qmail-remote
%attr(755,root,root)                    %{_prefix}/sbin/qmail-pw2u
%attr(755,root,root)                    %{_prefix}/sbin/recipient-cdb
%attr(755,root,root)                    %{_prefix}/sbin/cdbtest
%attr(755,root,root)                    %{_prefix}/sbin/cdbstats
%attr(755,root,root)                    %{_prefix}/sbin/cdbdump
%attr(755,root,root)                    %{_prefix}/sbin/cdbget
%attr(755,root,root)                    %{_prefix}/sbin/cdbgetm
%attr(755,root,root)                    %{_prefix}/sbin/cdbmake
%attr(755,root,root)                    %{_prefix}/sbin/qmail-newmrh
%attr(755,root,root)                    %{_prefix}/sbin/qscanq-stdin

%attr(755,root,root)                    %{_prefix}/sbin/plugtest
%attr(755,root,root)                    %{_prefix}/sbin/ldap-checkpwd
%attr(711,root,root)                    %{_prefix}/sbin/svctool
%attr(755,root,root)                    %{_prefix}/sbin/qmail-nullqueue
%attr(755,root,root)                    %{_prefix}/sbin/qmail-multi
%attr(755,root,root)                    %{_prefix}/sbin/cleanq
%attr(755,root,root)                    %{_prefix}/sbin/qmail-tcpok
%attr(755,root,root)                    %{_prefix}/sbin/qmail-tcpto
%attr(755,root,root)                    %{_prefix}/sbin/qmail-qmqpc
%attr(755,root,root)                    %{_prefix}/sbin/qmail-newu
%attr(755,root,root)                    %{_prefix}/sbin/cdb-database
%attr(755,root,root)                    %{_prefix}/sbin/sql-database
%attr(755,root,root)                    %{_prefix}/sbin/ctrlenv
%attr(755,root,root)                    %{_prefix}/sbin/qmail-cdb
%attr(755,root,root)                    %{_prefix}/sbin/qmail-sql

%attr(751,root,root)                    %{_prefix}/sbin/qmail-smtpd
%attr(751,root,root)                    %{_prefix}/sbin/qmail-qmqpd
%attr(751,root,root)                    %{_prefix}/sbin/qmail-qmtpd
%attr(751,root,root)                    %{_prefix}/sbin/qmail-daemon
%attr(751,root,root)                    %{_prefix}/sbin/qmail-start
%attr(751,root,root)                    %{_prefix}/sbin/qmail-lspawn
%attr(751,root,root)                    %{_prefix}/sbin/qmail-rspawn
%attr(751,root,root)                    %{_prefix}/sbin/qmail-clean
%attr(751,root,root)                    %{_prefix}/sbin/qmail-send
%attr(751,root,root)                    %{_prefix}/sbin/qmail-todo
%attr(755,root,root)                    %{_prefix}/sbin/surblfilter
%attr(755,root,root)                    %{_prefix}/sbin/surblqueue

%attr(755,root,root)                    %{_prefix}/sbin/relaytest
%attr(755,root,root)                    %{_prefix}/sbin/splogger

%attr(755,root,root)                    %{libexecdir}/columnt
%attr(755,root,root)                    %{libexecdir}/rpmattr
%attr(755,root,root)                    %{libexecdir}/leapsecs
%attr(755,root,root)                    %{libexecdir}/yearcal
%attr(755,root,root)                    %{libexecdir}/nowutc
%attr(755,root,root)                    %{libexecdir}/batv
%attr(755,root,root)                    %{libexecdir}/zsuccesses
%attr(755,root,root)                    %{libexecdir}/deferrals
%attr(755,root,root)                    %{libexecdir}/rsmtprecipients
%attr(755,root,root)                    %{libexecdir}/zrecipients
%attr(755,root,root)                    %{libexecdir}/xsender
%attr(755,root,root)                    %{libexecdir}/rxdelay
%attr(755,root,root)                    %{libexecdir}/zspam
%attr(755,root,root)                    %{libexecdir}/recipients
%attr(755,root,root)                    %{libexecdir}/rsmtprdomains
%attr(755,root,root)                    %{libexecdir}/rsmtpfailures
%attr(755,root,root)                    %{libexecdir}/successes
%attr(755,root,root)                    %{libexecdir}/rspamrdomain
%attr(755,root,root)                    %{libexecdir}/matchup
%attr(755,root,root)                    %{libexecdir}/mlmatchup
%attr(755,root,root)                    %{libexecdir}/multilog-matchup
%attr(755,root,root)                    %{libexecdir}/smtp-matchup
%attr(755,root,root)                    %{libexecdir}/xqp
%attr(755,root,root)                    %{libexecdir}/zddist
%attr(755,root,root)                    %{libexecdir}/zsenders
%attr(755,root,root)                    %{libexecdir}/senders
%attr(755,root,root)                    %{libexecdir}/suids
%attr(755,root,root)                    %{libexecdir}/zsmtp
%attr(755,root,root)                    %{libexecdir}/zoverall
%attr(755,root,root)                    %{libexecdir}/rhosts
%attr(755,root,root)                    %{libexecdir}/zrhosts
%attr(755,root,root)                    %{libexecdir}/failures
%attr(755,root,root)                    %{libexecdir}/rsmtp
%attr(755,root,root)                    %{libexecdir}/rsmtpsenders
%attr(755,root,root)                    %{libexecdir}/zdeferrals
%attr(755,root,root)                    %{libexecdir}/rspamstat
%attr(755,root,root)                    %{libexecdir}/zsuids
%attr(755,root,root)                    %{libexecdir}/xrecipient
%attr(755,root,root)                    %{libexecdir}/rspamhist
%attr(755,root,root)                    %{libexecdir}/rsmtpsdomains
%attr(755,root,root)                    %{libexecdir}/zfailures
%attr(755,root,root)                    %{libexecdir}/zsendmail
%attr(755,root,root)                    %{libexecdir}/ddist
%attr(755,root,root)                    %{libexecdir}/rspamsdomain
%attr(755,root,root)                    %{libexecdir}/zrxdelay
%attr(755,root,root)                    %{libexecdir}/qupgrade.sh
%verify (not md5 size mtime mode)       %{libexecdir}/qlocal_upgrade.sh

%attr(755,root,root)                    %{libexecdir}/atrn
%attr(755,root,root)                    %{libexecdir}/etrn
%attr(755,root,root)                    %{libexecdir}/cdbmake-12
%attr(755,root,root)                    %{libexecdir}/cdbmake-sv
%attr(755,root,root)                    %{libexecdir}/config-fast
%attr(755,root,root)                    %{libexecdir}/idedit
%attr(755,root,root)                    %{libexecdir}/hostname
%attr(755,root,root)                    %{libexecdir}/qmailconfig
%attr(755,root,root)                    %{libexecdir}/dnstxt
%attr(755,root,root)                    %{libexecdir}/dnsmxip
%attr(755,root,root)                    %{libexecdir}/dnsfq
%attr(755,root,root)                    %{libexecdir}/dnsptr
%attr(755,root,root)                    %{libexecdir}/dnsip
%attr(755,root,root)                    %{libexecdir}/dnscname
%if %notlsarr == 0
%attr(755,root,root)                    %{libexecdir}/dnstlsarr
%endif
%attr(755,root,root)                    %{libexecdir}/envmigrate
%attr(755,root,root)                    %{libexecdir}/qsmhook
%attr(755,root,root)                    %{libexecdir}/update_tmprsadh
%attr(755,root,root)                    %{libexecdir}/instcheck.indimail-mta
%attr(755,root,root)                    %{libexecdir}/whois
%attr(755,root,root)                    %{libexecdir}/testzero
%attr(755,root,root)                    %{libexecdir}/ipmeprint
%attr(755,root,root)                    %{libexecdir}/qpq
%attr(755,root,root)                    %{libexecdir}/qfrontend
%attr(755,root,root)                    %{libexecdir}/qfilters/qf-smtp-ratelimit

%docdir %{mandir}
%attr(0644,root,root)                   %{mandir}/man[1,4,5,7,8]/*

%attr(0755,root,root)                   %{shareddir}/boot/binm2
%attr(0755,root,root)                   %{shareddir}/boot/proc+df
%attr(0755,root,root)                   %{shareddir}/boot/binm1+df
%attr(0755,root,root)                   %{shareddir}/boot/binm3+df
%attr(0755,root,root)                   %{shareddir}/boot/home+df
%attr(0755,root,root)                   %{shareddir}/boot/binm3
%attr(0755,root,root)                   %{shareddir}/boot/binm1
%attr(0755,root,root)                   %{shareddir}/boot/proc
%attr(0755,root,root)                   %{shareddir}/boot/home
%attr(0755,root,root)                   %{shareddir}/boot/binm2+df

%attr(0755,root,root)                   %{plugindir}/generic.so
%attr(0755,root,root)                   %{plugindir}/smtpd-plugin.so
%attr(0755,root,root)                   %{plugindir}/smtpd-plugin0.so
%if %tcpserver_plugin != 0
%attr(0755,root,root)                   %{plugindir}/qmail_smtpd.so
%endif

%if %build_on_obs == 0
%license %attr(0644,root,root)          %{shareddir}/doc/COPYING-indimail-mta
%license %attr(0644,root,root)          %{shareddir}/doc/README.licenses
%license %attr(0644,root,root)          %{shareddir}/doc/LICENSE.qhpsi
%else
%attr(0644,root,root)                   %{shareddir}/doc/COPYING-indimail-mta
%attr(0644,root,root)                   %{shareddir}/doc/README.licenses
%attr(0644,root,root)                   %{shareddir}/doc/LICENSE.qhpsi
%endif
%attr(0644,root,root)                   %{shareddir}/doc/softwarelicense1-1.html
%attr(0644,root,root)                   %{shareddir}/doc/INSTALL.alias
%attr(0644,root,root)                   %{shareddir}/doc/INSTALL.control
%attr(0644,root,root)                   %{shareddir}/doc/INSTALL.maildir
%attr(0644,root,root)                   %{shareddir}/doc/INSTALL.mbox
%attr(0644,root,root)                   %{shareddir}/doc/INSTALL-MINI
%attr(0644,root,root)                   %{shareddir}/doc/INSTALL.vsm
%attr(0644,root,root)                   %{shareddir}/doc/README.clamav
%attr(0644,root,root)                   %{shareddir}/doc/README.EXTTODO
%attr(0644,root,root)                   %{shareddir}/doc/README.filters
%attr(0644,root,root)                   %{shareddir}/doc/README.greylist
%attr(0644,root,root)                   %{shareddir}/doc/README.indimail-mta
%attr(0644,root,root)                   %{shareddir}/doc/README.qhpsi
%attr(0644,root,root)                   %{shareddir}/doc/README.qregex
%attr(0644,root,root)                   %{shareddir}/doc/README.queue-fix
%attr(0644,root,root)                   %{shareddir}/doc/README.status
%attr(0644,root,root)                   %{shareddir}/doc/README.recipients
%attr(0644,root,root)                   %{shareddir}/doc/README.srs
%attr(0644,root,root)                   %{shareddir}/doc/README.surbl
%attr(0644,root,root)                   %{shareddir}/doc/CREDITS
%attr(0644,root,root)                   %{shareddir}/doc/ChangeLog-indimail-mta
%attr(0644,root,root)                   %{shareddir}/doc/INTERNALS
%attr(0644,root,root)                   %{shareddir}/doc/FROMISP
%attr(0644,root,root)                   %{shareddir}/doc/TOISP
%attr(0644,root,root)                   %{shareddir}/doc/AUTOTURN
%attr(0644,root,root)                   %{shareddir}/doc/PIC.local2alias
%attr(0644,root,root)                   %{shareddir}/doc/PIC.local2local
%attr(0644,root,root)                   %{shareddir}/doc/PIC.nullclient
%attr(0644,root,root)                   %{shareddir}/doc/PIC.rem2local
%attr(0644,root,root)                   %{shareddir}/doc/PIC.relaybad
%attr(0644,root,root)                   %{shareddir}/doc/PIC.local2ext
%attr(0644,root,root)                   %{shareddir}/doc/PIC.local2virt
%attr(0644,root,root)                   %{shareddir}/doc/PIC.relaygood
%attr(0644,root,root)                   %{shareddir}/doc/PIC.local2rem

%if 0%{?suse_version} >= 1120
%verify (not user group mode caps) %attr(6551, qscand, qmail)   %{_prefix}/sbin/qhpsi
%verify (not user group mode caps) %attr(2551, root, qscand)    %{_prefix}/sbin/run-cleanq
%verify (not user group mode caps) %attr(6551, qmailq, qmail)   %{_prefix}/sbin/qmail-queue
%verify (not user group mode caps) %attr(4551, qscand, qscand)  %{_prefix}/sbin/qscanq
%verify (not user group mode caps) %attr(4551, root, root)      %{_prefix}/sbin/sys-checkpwd
%else
%attr(6551,qscand,qmail)                %{_prefix}/sbin/qhpsi
%attr(2551,root,qscand)                 %{_prefix}/sbin/run-cleanq
%attr(6551,qmailq,qmail)                %{_prefix}/sbin/qmail-queue
%attr(4551,qscand,qscand)               %{_prefix}/sbin/qscanq
%attr(4551,root,root)                   %{_prefix}/sbin/sys-checkpwd
%endif

%files -n indimail-mini
%defattr(-, root, root, 0755)
#
# Directories
#
%dir %attr(0555,root,qmail)        %{qmaildir}
                                   %{qmaildir}/bin
                                   %{qmaildir}/sbin
                                   %{qmaildir}/users
                                   %{qmaildir}/control
%dir %attr(2775,indimail,qmail)    %{qsysconfdir}/control
%dir %attr(2775,indimail,qmail)    %{qsysconfdir}/users
%if "%{mandir}" != "/usr/share/man"
%dir %attr(0755,root,root)         %{mandir}
%dir %attr(0755,root,root)         %{mandir}/man1
%dir %attr(0755,root,root)         %{mandir}/man8
%endif
#
%attr(0755,root,root)              %{_prefix}/bin/sendmail
%attr(0755,root,root)              %{_prefix}/bin/qmail-inject
%attr(0755,root,root)              %{_prefix}/bin/irmail
%attr(0755,root,root)              %{_prefix}/bin/forward
%attr(0755,root,root)              %{_prefix}/bin/predate
%attr(0755,root,root)              %{_prefix}/bin/datemail
%attr(0755,root,root)              %{_prefix}/bin/mailsubj
%attr(0755,root,root)              %{_prefix}/bin/qmail-showctl
%attr(0755,root,root)              %{_prefix}/bin/qmaildirmake
%attr(0755,root,root)              %{_prefix}/bin/maildir2mbox
%attr(0755,root,root)              %{_prefix}/bin/maildirwatch
%attr(0755,root,root)              %{_prefix}/sbin/qmail-qmqpc

%if 0%{?suse_version} >= 1120
%attr(644,root,root)  %config(noreplace,missingok) %{_sysconfdir}/permissions.d/indimail-mta-permissions
%attr(644,root,root)  %config(noreplace,missingok) %{_sysconfdir}/permissions.d/indimail-mta-permissions.secure
%endif
#
%attr(0644,root,root)              %{mandir}/man1/forward.1.gz
%attr(0644,root,root)              %{mandir}/man1/predate.1.gz
%attr(0644,root,root)              %{mandir}/man1/datemail.1.gz
%attr(0644,root,root)              %{mandir}/man1/mailsubj.1.gz
%attr(0644,root,root)              %{mandir}/man1/qmaildirmake.1.gz
%attr(0644,root,root)              %{mandir}/man1/maildir2mbox.1.gz
%attr(0644,root,root)              %{mandir}/man1/maildirwatch.1.gz
#
%attr(0644,root,root)              %{mandir}/man5/qmail-srs.5.gz
#
%attr(0644,root,root)              %{mandir}/man8/qmail-showctl.8.gz
%attr(0644,root,root)              %{mandir}/man8/qmail-inject.8.gz
%attr(0644,root,root)              %{mandir}/man8/isendmail.8.gz
%attr(0644,root,root)              %{mandir}/man8/qmail-qmqpc.8.gz
%attr(0644,root,root)              %{mandir}/man8/irmail.8.gz

%attr(0644,root,root)              %{shareddir}/doc/INSTALL-MINI

# a copy of /var/qmail/control/me, /var/qmail/control/defaultdomain,
# and /var/qmail/control/plusdomain from your central server, so that
# qmail-inject uses appropriate host names in outgoing mail; and
# this host's name in /var/qmail/control/idhost, so that
# qmail-inject generates Message-ID without any risk of collision


%clean
[ "%{buildroot}" != "/" ] && %{__rm} -fr %{buildroot}
%{__rm} -fr %{_builddir}/%{name}-%{version}

# value of argv1 ($1) passed to scriptlets
#            install   erase   upgrade  reinstall
# pretrans      0        -         0
# pre           1        -         2         2
# post          1        -         2         2
# preun         -        0         1         -
# postun        -        0         1         -
# posttrans     0        -         0
# The scriptlets in %%pre and %%post are respectively run before and after a package is installed.
# The scriptlets %%preun and %%postun are run before and after a package is uninstalled.
# The scriptlets %%pretrans and %%posttrans are run at start and end of a transaction.
# On upgrade, the scripts are run in the following order:
#
#   1. pretrans of new package
#   2. pre of new package
#   3. (package install)
#   4. post of new package
#   5. preun of old package
#   6. (removal of old package)
#   7. postun of old package
#   8. posttrans of new package

### SCRIPTLET ###############################################################################
%verifyscript
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
%{_prefix}/sbin/svctool --check-install --servicedir=%{servicedir} \
  --qbase=%{qbase} --qcount=%{qcount} --qstart=1

%if 0%{?suse_version} >= 1120
%verify_permissions -e %{_prefix}/sbin/qhpsi
%verify_permissions -e %{_prefix}/sbin/run-cleanq
%verify_permissions -e %{_prefix}/sbin/qmail-queue
%verify_permissions -e %{_prefix}/sbin/qscanq
%verify_permissions -e %{_prefix}/sbin/sys-checkpwd
%verify_permissions -e %{qmaildir}/alias/
%verify_permissions -e %{qmaildir}/autoturn/
%verify_permissions -e %{qsysconfdir}/
%verify_permissions -e %{qsysconfdir}/certs/
%verify_permissions -e %{qsysconfdir}/control/
%verify_permissions -e %{qsysconfdir}/control/cache/
%verify_permissions -e %{qsysconfdir}/control/domainkeys/
%verify_permissions -e %{qsysconfdir}/control/ratelimit/
%verify_permissions -e %{qsysconfdir}/tcp/
%verify_permissions -e %{qsysconfdir}/users/
%endif

### SCRIPTLET ###############################################################################
%pretrans
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
(
if [ -d /run ] ; then
  rundir=/run/svscan
elif [ -d /var/run ] ; then
  rundir=/var/run/svscan
else
  rundir=%{servicedir}
fi
echo "shutting down indimail-mta services"
for i in greylist.1999 qmail-daned.1998 qmail-qmqpd.628 \
  qmail-qmtpd.209 qmail-send.25 qmail-smtpd.25 \
  qmail-smtpd.366 qmail-smtpd.465 qmail-smtpd.587 \
  qscanq resolvconf udplogger.3000
do
  %{_prefix}/bin/svstat %{servicedir}/$i >/dev/null 2>&1
  if [ $? -eq 0 ] ; then
    %{__mkdir_p} %{rundir}/$i
    touch %{rundir}/$i/.down
    %{_prefix}/bin/svc -d %{servicedir}/$i
  fi
done
if [ -f %{libexecdir}/qupgrade.sh ] ; then
  echo "Running Custom Upgrade Script for pretrans"
  /bin/sh %{libexecdir}/qupgrade.sh pretrans noargs %{version} $*
fi
) > /var/log/%{name}-setup.log 2>&1

### SCRIPTLET ###############################################################################
%pre
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 2 ] ; then
  if [ -f %{libexecdir}/qupgrade.sh ] ; then
  (
    echo "Running Custom Upgrade Script for pre upgrade"
    /bin/sh %{libexecdir}/qupgrade.sh pre upgrade %{version} $*
  ) >> /var/log/%{name}-setup.log 2>&1
  fi
  exit 0
fi
#
# Create a users and groups. Do not report any problems if they already
# exists.
#
(
nscd_up=`ps -ef |grep nscd |grep -v grep|wc -l`
if [ $nscd_up -ge 1 ] ; then
  if [ -x %{_sysconfdir}/init.d/nscd ] ; then
    %{_sysconfdir}/init.d/nscd stop
  fi
fi
echo "Adding indimail-mta users/groups"
/usr/bin/getent group %groupname  > /dev/null || /usr/sbin/groupadd -r -g %gid %groupname || true
if [ $? = 4 ] ; then
  /usr/sbin/groupadd %groupname
fi
/usr/bin/getent group nofiles   > /dev/null || /usr/sbin/groupadd nofiles  || true
/usr/bin/getent group qmail     > /dev/null || /usr/sbin/groupadd qmail    || true
/usr/bin/getent group qscand    > /dev/null || /usr/sbin/groupadd qscand   || true

/usr/bin/getent passwd %username > /dev/null || /usr/sbin/useradd -r -g %groupname -u %uid -d %{qmaildir} %username || true
if [ $? = 4 ] ; then
  /usr/sbin/useradd -r -g %groupname -d %{qmaildir} %username
fi
/usr/bin/getent passwd alias    > /dev/null || /usr/sbin/useradd -M -g nofiles  -d %{qmaildir}/alias  -s /sbin/nologin alias  || true
/usr/bin/getent passwd qmaild   > /dev/null || /usr/sbin/useradd -M -g nofiles  -d %{qmaildir}        -s /sbin/nologin qmaild || true
/usr/bin/getent passwd qmaill   > /dev/null || /usr/sbin/useradd -M -g nofiles  -d %{logdir}          -s /sbin/nologin qmaill || true
/usr/bin/getent passwd qmailp   > /dev/null || /usr/sbin/useradd -M -g nofiles  -d %{qmaildir}        -s /sbin/nologin qmailp || true
/usr/bin/getent passwd qmailq   > /dev/null || /usr/sbin/useradd -M -g qmail    -d %{qmaildir}        -s /sbin/nologin qmailq || true
/usr/bin/getent passwd qmailr   > /dev/null || /usr/sbin/useradd -M -g qmail    -d %{qmaildir}        -s /sbin/nologin qmailr || true
/usr/bin/getent passwd qmails   > /dev/null || /usr/sbin/useradd -M -g qmail    -d %{qmaildir}        -s /sbin/nologin qmails || true
/usr/bin/getent passwd qscand   > /dev/null || /usr/sbin/useradd -M -g qscand   -d %{qmaildir}/qscanq -G qmail,qscand -s /sbin/nologin qscand || true

for i in %username alias qmaild qmaill qmailp qmailq qmailr qmails qscand
do
  %{__rm} -f /var/spool/mail/$i
done
if [ $nscd_up -ge 1 ] ; then
  if [ -x %{_sysconfdir}/init.d/nscd ] ; then
    %{_sysconfdir}/init.d/nscd start
  fi
fi
) >> /var/log/%{name}-setup.log 2>&1

### SCRIPTLET ###############################################################################
%post
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
if [ -z "$argv1" ] ; then
  argv1=0
fi
if [ $argv1 -eq 2 ] ; then # upgrade
  (
  echo "doing post upgrade activities"
  if [ -f %{libexecdir}/qupgrade.sh ] ; then
    if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
      /sbin/ldconfig
    fi
    echo "Running Custom Upgrade Script for post upgrade"
    /bin/sh %{libexecdir}/qupgrade.sh post upgrade %{version} $*
  fi
  # selinux
  %{_prefix}/sbin/svctool --servicedir=%{servicedir} --config=qselinux
  if [ -f %{_sysconfdir}/inittab ] ; then # one of these days, this will disappear
    /bin/grep "^#SV:" %{_sysconfdir}/inittab |/bin/grep svscan |/bin/grep respawn >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
      %{__sed} -i 's{^#SV:{SV:{' %{_sysconfdir}/inittab
    fi
  fi

  # refresh indimail-mta services
  svc_list=""
  for i in clamd greylist.1999 qmail-qmqpd.628 \
    qmail-qmtpd.209 qmail-smtpd.25 qmail-smtpd.366 \
    qmail-smtpd.465 qmail-smtpd.587 qscanq udplogger.3000 \
    qmail-daned.1998
  do
    if [ -d %{servicedir}/$i ] ; then
      if [ -z "$svc_list" ] ; then
        svc_list="%{servicedir}/$i"
      else
        svc_list="$svc_list %{servicedir}/$i"
      fi
    fi
  done
  svc_list="$svc_list %{qsysconfdir}/control/defaultqueue"
  %{_prefix}/sbin/svctool --servicedir=%{servicedir} --refreshsvc="$svc_list"

  echo "starting indimail-mta services"
  if [ -d /run ] ; then
    rundir=/run/svscan
  elif [ -d /var/run ] ; then
    rundir=/var/run/svscan
  else
    rundir=%{servicedir}
  fi
  for i in greylist.1999 qmail-daned.1998 qmail-qmqpd.628 \
    qmail-qmtpd.209 qmail-send.25 qmail-smtpd.25 \
    qmail-smtpd.366 qmail-smtpd.465 qmail-smtpd.587 \
    qscanq resolvconf udplogger.3000
  do
    %{_prefix}/bin/svok %{servicedir}/$i
    if [ $? -eq 0 -a -f %{rundir}/$i/.down ] ; then
      %{__rm} -f %{rundir}/$i/.down
      %{_prefix}/bin/svc -u %{servicedir}/$i
    fi
  done
  ) >> /var/log//%{name}-setup.log 2>&1
  exit 0
fi

echo "Doing Post Install"
echo ""
echo " 1. Configure %{logdir} for multilog"
echo " 2. Configure %{servicedir}"
echo " 3. Configure standard catch-all accounts, default qmail configuration"
echo " 4. Configure DKIM, Domainkeys signature"
echo " 5. Configure QHPSI for inline virus scanning"
echo " 6. Configure SMTP services on port in 465 25 587"
echo " 7. Configure default queue configuration for sendmail, qmail-inject"
echo " 8. Configure ODMR service"
echo " 9. Configure greylisting service"
echo "10. Configure QMTP service"
echo "11. Configure QMQP service"
echo "12. Configure udplogger service"
echo "13. Configure qscanq/clamd/freshclam service"
echo "14. Configure %{qsysconfdir}/control/signatures"
echo "15. Configure tcprules database for SMTP, QMTP, QMQP"
echo ""

if [ ! -d %{logdir} ] ; then
  echo "Creating %{logdir}"
  %{__mkdir_p} %{logdir}
fi
%{__chown} -R qmaill:nofiles %{logdir}

(
%{_prefix}/sbin/svctool --config=qmail --postmaster=%{qmaildir}/alias/Maildir/

if [ %nodksignatures -eq 0 ] ; then
  if [ -x %{_prefix}/bin/dknewkey ] ; then
    ver_opt="dkim"
    sign_opt="dkim"
    key_bit=$KEYBIT # set KEYBIT in environment variable
    if [ " $key_bit" = " " ] ; then
      key_bit=1024
    fi
    %{_prefix}/bin/dknewkey %{qsysconfdir}/control/domainkeys/%{dkimkeyfn} $key_bit
    %{__chown} indimail:qmail %{qsysconfdir}/control/domainkeys/%{dkimkeyfn}
    /bin/chmod 640 %{qsysconfdir}/control/domainkeys/%{dkimkeyfn}
  else
    ver_opt="none"
    sign_opt="none"
  fi
else
  ver_opt="none"
  sign_opt="none"
fi

%if 0%{?suse_version} >= 1120
%if 0%{?set_permissions:1} > 0
  %set_permissions %{_prefix}/sbin/qhpsi
  %set_permissions %{_prefix}/sbin/qmail-queue
  %set_permissions %{_prefix}/sbin/qscanq
  %set_permissions %{_prefix}/sbin/run-cleanq
  %set_permissions %{_prefix}/sbin/sys-checkpwd
  %set_permissions %{qmaildir}/alias/
  %set_permissions %{qmaildir}/autoturn/
  %set_permissions %{qsysconfdir}/
  %set_permissions %{qsysconfdir}/certs/
  %set_permissions %{qsysconfdir}/control/
  %set_permissions %{qsysconfdir}/control/cache/
  %set_permissions %{qsysconfdir}/control/domainkeys/
  %set_permissions %{qsysconfdir}/control/ratelimit/
  %set_permissions %{qsysconfdir}/tcp/
  %set_permissions %{qsysconfdir}/users/
%else
  %run_permissions
%endif
%endif

# SMTP
%ifarch x86_64
%global smtp_soft_mem 104857600
%global qmtp_soft_mem 104857600
%global qmqp_soft_mem 104857600
%global send_soft_mem 104857600
%else
%global smtp_soft_mem 26214400
%global qmtp_soft_mem 26214400
%global qmqp_soft_mem 26214400
%global send_soft_mem 83886080
%endif

# Define QHPSI for inline virus scanning by qmail-queue
if [ -f /usr/sbin/clamd -a -f /usr/bin/clamdscan ] ; then
  have_clamav=1
  clamdPrefix="/usr"
  if [ -d %{_sysconfdir}/clamav ] ; then
    mysysconfdir=%{_sysconfdir}/clamav
  elif [ -d %{_sysconfdir}/clamd.d ] ; then
    mysysconfdir=%{_sysconfdir}/clamd.d
  elif [ -d %{qsysconfdir} ] ; then
    mysysconfdir=%{qsysconfdir}
  else
    mysysconfdir=%{_sysconfdir}
  fi
  qhpsi="/usr/bin/clamdscan %s --config=${mysysconfdir}/scan.conf --fdpass --quiet --no-summary"
  # let qscand get qmail group for socket permission
  /usr/sbin/usermod -aG qmail qscand || true
else
  have_clamav=0
fi
# SMTP ports
for port in 465 25 587
do
  extra_opt=""
  if [ $port -eq 465 ] ; then
    extra_opt="--skipsend --authsmtp --ssl"
    extra_opt="$extra_opt --rbl=-rzen.spamhaus.org --rbl=-rdnsbl-1.uceprotect.net"
  elif [ $port -eq 587 ] ; then
    extra_opt="--skipsend --forceauthsmtp --antispoof --forcetls"
  else
    if [ $port -eq 25 ] ; then
      extra_opt="--remote-authsmtp=plain --localfilter --remotefilter"
      extra_opt="--dmemory=%{send_soft_mem}"
    else
      extra_opt="--authsmtp"
    fi
    extra_opt="$extra_opt --deliverylimit-count=-1 --deliverylimit-size=-1"
    extra_opt="$extra_opt --rbl=-rzen.spamhaus.org --rbl=-rdnsbl-1.uceprotect.net"
  fi
%if %{tcpserver_plugin} == 1
    extra_opt="$extra_opt --shared-objects=1 --use-dlmopen=1"
%endif
  if [ $have_clamav -eq 1 ] ; then
    extra_opt="$extra_opt --qhpsi=\"$qhpsi\""
  fi
  eval %{_prefix}/sbin/svctool --smtp=$port --servicedir=%{servicedir} \
    --qbase=%{qbase} --qcount=%{qcount} --qstart=1 \
    --query-cache --dnscheck --password-cache \
    --cntrldir=control --localip=0 --maxdaemons=75 --maxperip=25 --persistdb \
    --starttls --fsync --syncdir --memory=%{smtp_soft_mem} \
    --chkrecipient --chkrelay --masquerade \
    --min-free=52428800 --content-filter --virus-filter \
    --dmasquerade --infifo=infifo \
    --dkverify=${ver_opt} \
    --dksign=${sign_opt} --private_key="%{qsysconfdir}/control/domainkeys/%/%{dkimkeyfn}" \
    $extra_opt
done

# queue parameters in control/defaultqueue for qmail-inject, sendmail
extra_opt=""
if [ $have_clamav -eq 1 ] ; then
  extra_opt="--qhpsi=\"$qhpsi\""
fi
eval %{_prefix}/sbin/svctool --queueParam=defaultqueue \
  --qbase=%{qbase} --qcount=%{qcount} --qstart=1 \
  --min-free=52428800 --fsync --syncdir --virus-filter \
  --dkverify="none" --dksign=$sign_opt \
  --private_key=%{qsysconfdir}/control/domainkeys/%/%{dkimkeyfn} \
  $extra_opt

# ODMR service
%{_prefix}/sbin/svctool --smtp=366 --odmr --servicedir=%{servicedir} \
  --infifo="" --query-cache --password-cache --skipsend --memory=%{smtp_soft_mem}

# Greylist daemon
%{_prefix}/sbin/svctool --greylist=1999 --servicedir=%{servicedir} --min-resend-min=2 \
    --resend-win-hr=24 --timeout-days=30 --context-file=greylist.context \
    --hash-size=65535 --save-interval=5 --whitelist=greylist.white
if [ %{notlsarr} -eq 0 ] ; then
  # qmail-daned tlsa daemon
  %{_prefix}/sbin/qmail-daned > /dev/null 2>&1 || \
  (test $? -ne 100 && %{_prefix}/sbin/svctool \
    --tlsa=1998 --servicedir=%{servicedir} \
    --timeout-days=30 --context-file=tlsa.context \
    --hash-size=65535 --save-interval=5 --whitelist=tlsa.white ) || \
    echo "Not enabling qmail-daned service" 1>&2
fi
# qmail-qmtpd service
eval %{_prefix}/sbin/svctool --qmtp=209 --servicedir=%{servicedir} --qbase=%{qbase} \
  --qcount=%{qcount} --qstart=1 --cntrldir=control --localip=0 --maxdaemons=75 --maxperip=25 \
  --fsync --syncdir --memory=%{qmtp_soft_mem} --min-free=52428800 $extra_opt
# qmail-qmqpd service
eval %{_prefix}/sbin/svctool --qmqp=628 --servicedir=%{servicedir} --qbase=%{qbase} \
  --qcount=%{qcount} --qstart=1 --cntrldir=control --localip=0 --maxdaemons=75 --maxperip=25 \
  --fsync --syncdir --memory=%{qmqp_soft_mem} --min-free=52428800 $extra_opt
touch %{servicedir}/qmail-qmqpd.628/down

# virus/spam filtering
%{_prefix}/sbin/svctool --qscanq --servicedir=%{servicedir} --scanint=200
if [ $have_clamav -eq 1 ] ; then
  %{_prefix}/sbin/svctool --config=clamd
  %{_prefix}/sbin/svctool --config=foxhole
  # create clamd, freshclam service
 eval %{_prefix}/sbin/svctool --clamd --servicedir=%{servicedir} --clamdPrefix=$clamdPrefix \
    --sysconfdir=${mysysconfdir}
  if [ $have_clamav -eq 1 ] ; then
    echo "Checking if clamd/freshclam is running"
    count=`ps -e|grep clamd|wc -l`
    if [ $count -gt 0 ] ; then
      echo "Disabling clamd service"
      touch %{servicedir}/clamd/down
    fi
    count=`ps -e|grep freshclam|wc -l`
    if [ $count -gt 0 ] ; then
      echo "Disabling freshclam service"
      touch %{servicedir}/freshclam/down
    fi
  fi
fi

# udplogger service
%{_prefix}/sbin/svctool --udplogger=3000 --localip=0 --timeout=10 --servicedir=%{servicedir}

%{__cat} <<EOF > %{qsysconfdir}/control/signatures
# Windows executables seen in active virii
TVqQAAMAA:
TVpQAAIAA
# Additional windows executable signatures not yet seen in virii
TVpAALQAc
TVpyAXkAX
TVrmAU4AA
TVrhARwAk
TVoFAQUAA
TVoAAAQAA
TVoIARMAA
TVouARsAA
TVrQAT8AA
# .ZIPfile signature seen in SoBig.E and mydoom:
#UEsDBBQAA:SoBig.e Virus
#UEsDBAoAAA:mydoom Virus
# .GIF file found in a previous Microsoft virus making the rounds.
R0lGODlhaAA7APcAAP///+rp6puSp6GZrDUjUUc6Zn53mFJMdbGvvVtXh2xre8bF1x8cU4yLprOy:Virus in .gif files
# http://www.gossamer-threads.com/lists/qmail/users/114447
UEsDBAoAAQAAAEBHYzCf4kJRDDAAAAAwAAAKAAAAc3ZtaXhlLmV4ZcuI1rOkjfn48VwCkMYHRTfM
EOF
%{__chown} qscand:qscand %{qsysconfdir}/control/signatures

# Recreate ld.so links and cache
if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  if [ -d %{_sysconfdir}/ld.so.conf.d ] ; then
    echo %{_libdir} > %{_sysconfdir}/ld.so.conf.d/indimail-%{_arch}.conf
  fi
  /sbin/ldconfig
fi

# rebuild cdb
for i in smtp qmtp qmqp
do
  for j in `/bin/ls %{qsysconfdir}/tcp/tcp*.$i 2>/dev/null`
  do
    t1=`date +'%s' -r $j`
    if [ -f $j.cdb ] ; then
      t2=`date +'%s' -r $j.cdb`
    else
      t2=0
    fi
    if [ $t1 -gt $t2 ] ; then
      echo "Creating CDB $j.cdb"
      %{_prefix}/bin/tcprules $j.cdb $j.tmp < $j && /bin/chmod 664 $j.cdb \
        && chown indimail:indimail $j.cdb
    fi
  done
done

# turn off automatic refresh for services during first time installation
svc_list=""
for i in clamd greylist.1999 qmail-qmqpd.628 \
  qmail-qmtpd.209 qmail-smtpd.25 qmail-smtpd.366 \
  qmail-smtpd.465 qmail-smtpd.587 qscanq udplogger.3000 \
  qmail-daned.1998
do
  if [ -d %{servicedir}/$i ] ; then
    svc_list="$svc_list %{servicedir}/$i"
  fi
done
svc_list="$svc_list %{qsysconfdir}/control/defaultqueue"
%{_prefix}/sbin/svctool --servicedir=%{servicedir} --norefreshsvc="0 $svc_list"

# selinux
%{_prefix}/sbin/svctool --servicedir=%{servicedir} --config=qselinux

echo "configuring indimail-mta as alternatives"
%{_prefix}/sbin/svctool --config=add-alt

if [ -f %{qsysconfdir}/cronlist.q -a -d %{_sysconfdir}/cron.d ] ; then
  echo "adding cron entries"
  %{__cp} %{qsysconfdir}/cronlist.q %{_sysconfdir}/cron.d
fi

if [ -f %{libexecdir}/qupgrade.sh ] ; then
  echo "Running Custom Installation Script for post install"
  /bin/sh %{libexecdir}/qupgrade.sh post install %{version} $*
fi
) >> /var/log/%{name}-setup.log 2>&1
if [ -f %{_sysconfdir}/init/svscan.conf -o -f %{_sysconfdir}/event.d/svscan ] ; then
  echo "1. Execute /sbin/initctl emit qmailstart to start services"
  count=1
elif [ -f %{_sysconfdir}/systemd/system/multi-user.target.wants/svscan.service ] ; then
  echo "1. Execute /bin/systemctl start svscan to start services"
  count=1
else
  if [ -f %{_prefix}/sbin/initsvc ] ; then
  echo "1. Execute %{_prefix}/sbin/initsvc -on"
  else
  echo "1. Execute %{_sysconfdir}/init.d/svscan start"
  fi
  echo "2. Execute /sbin/init q to start services"
  count=2
fi
default_domain=$([ -n "$HOSTNAME" ] && echo "$HOSTNAME" || `uname -n`)
count=`expr $count + 1`
echo "$count. Change your default domain in %{qsysconfdir}/control/defaultdomain"
count=`expr $count + 1`
echo "$count. You can optionally run the following command to verify installation"
echo "   sudo rpm -V indimail"
if [ ! -f %{qsysconfdir}/certs/servercert.pem ] ; then
count=`expr $count + 1`
echo "$count. You need to create CERTS for SSL/TLS/STARTTLS"
echo "   Execute the following command to create the certificate"
echo "   %{_prefix}/sbin/svctool --config=cert --postmaster=postmaster@$default_domain --common_name=$default_domain"
fi
echo
echo "Look at /var/log/%{name}-setup.log for the installation log"

### SCRIPTLET ###############################################################################
%preun
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
(
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 1 ] ; then
  (
  if [ -f %{libexecdir}/qupgrade.sh ] ; then
    echo "Running Custom Un-Installation Script for preun upgrade"
    /bin/sh %{libexecdir}/qupgrade.sh preun upgrade %{version} "$argv1"
  fi
  ) >> /var/log/%{name}-setup.log 2>&1
  exit 0
fi

if [ -f %{libexecdir}/qupgrade.sh ] ; then
  echo "Running Custom Un-Installation Script for preun pre-uninstall"
  /bin/sh %{libexecdir}/qupgrade.sh preun uninstall %{version} "$argv1"
fi

echo "shutting down and removing indimail-mta/indimail-mta-log services"
for i in qmail-send.25 qmail-smtpd.25 qmail-smtpd.366 \
  qscanq qmail-smtpd.465 qmail-smtpd.587 \
  qmail-qmtpd.209 qmail-qmqpd.628 greylist.1999 \
  qmail-daned.1998 resolvconf udplogger.3000
do
  if [ -d %{servicedir}/$i -o -L %{servicedir}/$i ] ; then
    touch %{servicedir}/$i/down
    svc -dx %{servicedir}/$i
  fi
  if [ -d %{servicedir}/$i/log -o -L %{servicedir}/$i/log ] ; then
    touch %{servicedir}/$i/log/down
    svc -dx %{servicedir}/$i/log
  fi
  if [ -d %{servicedir}/$i -o -L %{servicedir}/$i ] ; then
    %{__rm} -rf %{servicedir}/$i || true
  fi
done

if [ -f %{_sysconfdir}/init.d/svscan ] ; then
  if [ -f /sbin/chkconfig ] ; then
    /sbin/chkconfig --add sendmail
  fi
fi
echo "removing indimail-mta as alternatives"
%{_prefix}/sbin/svctool --config=remove-alt
) >> /var/log/%{name}-setup.log 2>&1

### SCRIPTLET ###############################################################################
%postun
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 1 ] ; then
  if [ -f %{libexecdir}/qupgrade.sh ] ; then
    (
    echo "Running Custom Un-Installation Script for postun upgrade"
    /bin/sh %{libexecdir}/qupgrade.sh postun upgrade %{version} $*
    ) >> /var/log/%{name}-setup.log
  fi
  if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
    echo "recreating ld.so cache"
    /sbin/ldconfig
  fi
  exit 0
fi
(
# remove users / groups
nscd_up=`ps -ef |grep nscd |grep -v grep|wc -l`
if [ $nscd_up -ge 1 ] ; then
  if [ -x %{_sysconfdir}/init.d/nscd ] ; then
    %{_sysconfdir}/init.d/nscd stop
  fi
fi
for i in alias qmaild qmailp qmailq qmailr qmails qscand indimail
do
  echo "Removing user $i"
  /usr/bin/getent passwd $i > /dev/null && /usr/sbin/userdel $i >/dev/null || true
done
for i in qmail qscand indimail
do
  echo "Removing group $i"
  /usr/bin/getent group $i > /dev/null && /usr/sbin/groupdel $i  >/dev/null || true
done
if [ $nscd_up -ge 1 ] ; then
  if [ -x %{_sysconfdir}/init.d/nscd ] ; then
    %{_sysconfdir}/init.d/nscd start
  fi
fi

for i in postmaster mailer-daemon root ham spam register-ham register-spam
do
  %{__rm} -f %{qmaildir}/alias/.qmail-"$i"
done
%{__rm} -rf %{qmaildir}/alias/Maildir

echo "removing svscan supervised startup services"
if [ -f /usr/sbin/clamd -a -f /usr/bin/clamdscan ] ; then
  for i in clamd freshclam
  do
    if [ -d %{servicedir}/$i ] ; then
      %{__rm} -rf %{servicedir}/$i || true
    elif [ -L %{servicedir}/$i ] ; then
      %{__rm} -rf %{servicedir}/$i || true
    fi
  done
fi

count=`/bin/ls %{servicedir} 2>/dev/null| /usr/bin/wc -l`
if [ $count -eq 0 ] ; then # ignore disabled services
  %{__rm} -rf %{servicedir} || true
fi

if [ -d %{_sysconfdir}/cron.d ] ; then
  echo "removing cron entries"
  %{__rm} -f %{_sysconfdir}/cron.d/cronlist.q
fi

echo "removing logs"
if [ -h %{logdir} ] ; then
  log_dir=`/bin/ls -ld %{logdir} | /usr/bin/awk '{print $10}'`
else
  log_dir=%{logdir}
fi
[ "$log_dir" != "/" ] && %{__rm} -fr $log_dir

if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  echo "recreating ld.so cache"
  /sbin/ldconfig
fi

#selinux
if [ -x /usr/sbin/selinuxenabled ] ; then
  /usr/sbin/selinuxenabled
  if [ $? -eq 0 -a -x /usr/sbin/semodule ] ; then
    echo "disabling selinux module"
    /usr/sbin/semodule -r indimail-mta
  fi
fi

if [ -f %{libexecdir}/qupgrade.sh ] ; then
  echo "Running Custom Un-Installation Script for postun uninstall"
  /bin/sh %{libexecdir}/qupgrade.sh postun uninstall %{version} $*
fi
) >> /var/log/%{name}-setup.log 2>&1

### SCRIPTLET ###############################################################################
%posttrans
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
if [ -f %{libexecdir}/qupgrade.sh ] ; then
(
  echo "Running Custom Installation Script for posttrans"
  /bin/sh %{libexecdir}/qupgrade.sh posttrans noargs %{version} $*
) >> /var/log/%{name}-setup.log 2>&1
fi

%verifyscript -n indimail-mini
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
%if 0%{?suse_version} >= 1120
%verify_permissions -e %{qsysconfdir}/
%verify_permissions -e %{qsysconfdir}/control/
%verify_permissions -e %{qsysconfdir}/users/
%endif

%post -n indimail-mini
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 2 ] ; then
  if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
    echo "recreating ld.so cache"
    /sbin/ldconfig
  fi
  exit 0
fi
(
#
# Create user/groups indimail. Do not report any problems if it already
# exists.
#
nscd_up=`ps -ef |grep nscd |grep -v grep|wc -l`
if [ $nscd_up -ge 1 ] ; then
  if [ -x %{_sysconfdir}/init.d/nscd ] ; then
    %{_sysconfdir}/init.d/nscd stop
  elif [ -f %{_sysconfdir}/lib/systemd/system/multi-user.target/nscd.service ] ; then
    /bin/systemctl start nscd.service
  fi
fi
echo "Adding IndiMail users/groups"
/usr/bin/getent group indimail  > /dev/null || /usr/sbin/groupadd -r -g 555 indimail || true
if [ $? = 4 ] ; then
  /usr/sbin/groupadd indimail
fi
/usr/bin/getent group nofiles   > /dev/null || /usr/sbin/groupadd nofiles  || true
/usr/bin/getent group qmail     > /dev/null || /usr/sbin/groupadd qmail    || true

%{__rm} -f /var/spool/mail/indimail

/usr/bin/getent passwd indimail > /dev/null || /usr/sbin/useradd -r -g indimail -u 555 -d %{qmaildir} indimail || true
if [ $? = 4 ] ; then
  /usr/sbin/useradd -r -g indimail -d %{qmaildir} indimail
fi
if [ $nscd_up -ge 1 ] ; then
  if [ -x %{_sysconfdir}/init.d/nscd ] ; then
    %{_sysconfdir}/init.d/nscd start
  elif [ -f %{_sysconfdir}/lib/systemd/system/multi-user.target/nscd.service ] ; then
    /bin/systemctl start nscd.service
  fi
fi

%if 0%{?suse_version} >= 1120
%if 0%{?set_permissions:1} > 0
  %set_permissions %{qsysconfdir}/control/
  %set_permissions %{qsysconfdir}/users/
%else
  %run_permissions
%endif
%endif

if [ -f %{_prefix}/sbin/qmail-qmqpc ] ; then
  %{__mv} %{_prefix}/sbin/qmail-queue %{_prefix}/sbin/qmail-queue.orig
fi
cd %{_prefix}/sbin
/bin/ln -sf qmail-qmqpc qmail-queue
if [ -f %{_sysconfdir}/init.d/sendmail ] ; then
  %{_sysconfdir}/init.d/sendmail stop
  if [ -f /sbin/chkconfig ] ; then
    /sbin/chkconfig --del sendmail
  fi
fi
if [ -x /usr/sbin/alternatives ] ; then
  alternatives_cmd=/usr/sbin/alternatives
elif [ -x /usr/sbin/update-alternatives ] ; then
  alternatives_cmd=/usr/sbin/update-alternatives
else
  alternatives_cmd=""
fi
if [ -n $alternatives_cmd ] ; then
  for i in /usr/lib/sendmail /usr/sbin/sendmail; do
    if [ -f $i -a ! -L $i ]; then
      echo "! $i is a file, should be a link" 1>&2
      %{__mv} $i $i.old
    fi
  done
  for i in mailq newaliases; do
    if [ -f /usr/share/man/man1/$i.1.gz -a ! -L /usr/share/man/man1/$i.1.gz ] ; then
      echo "! /usr/share/man/man1/$i.1.gz is a file, should be a link" 1>&2
      %{__mv} /usr/share/man/man1/$i.1.gz /usr/share/man/man1/$i.old.1.gz
    fi
  done
  if [ -f %{_sysconfdir}/pam.d/smtp -a ! -L %{_sysconfdir}/pam.d/smtp ] ; then
    echo "! %{_sysconfdir}/pam.d/smtp is a file, should be a link" 1>&2
    %{__mv} %{_sysconfdir}/pam.d/smtp %{_sysconfdir}/pam.d/smtp.old
  fi
  $alternatives_cmd --install \
    /usr/sbin/sendmail mta %{_prefix}/bin/sendmail 120 \
    --slave /usr/share/man/man8/sendmail.8.gz mta-sendmailman \
      %{mandir}/man8/isendmail.8.gz \
    --slave /usr/lib/sendmail mta-sendmail %{_prefix}/bin/sendmail \
    --slave /usr/bin/rmail mta-rmail %{_prefix}/bin/irmail
  $alternatives_cmd --set mta %{_prefix}/bin/sendmail
else
  for i in /usr/lib/sendmail /usr/sbin/sendmail; do
    if [ -f $i -a ! -L $i ]; then
      echo "! $i is a file, should be a link" 1>&2
      %{__mv} $i $i.old
      /bin/ln -s %{_prefix}/bin/sendmail $i
    elif [ -L $i ];then
      %{__mv} $i $i.old
      /bin/ln -s %{_prefix}/bin/sendmail $i
    elif [ ! -f $i ];then
      echo "! $i is missing"
      /bin/ln -s %{_prefix}/bin/sendmail $i
    fi
  done
  if [ -f %{_sysconfdir}/pam.d/smtp -a ! -L %{_sysconfdir}/pam.d/smtp ] ; then
    echo "! %{_sysconfdir}/pam.d/smtp is a file, should be a link" 1>&2
    %{__mv} %{_sysconfdir}/pam.d/smtp %{_sysconfdir}/pam.d/smtp.old
    /bin/ln -s %{_sysconfdir}/pam.d/pam.multi %{_sysconfdir}/pam.d/smtp
  fi
  for i in mailq newaliases; do
    if [ -f /usr/share/man/man1/$i.1.gz -a ! -L /usr/share/man/man1/$i.1.gz ] ; then
      echo "! /usr/share/man/man1/$i.1.gz is a file, should be a link" 1>&2
      %{__mv} /usr/share/man/man1/$i.1.gz /usr/share/man/man1/$i.old.1.gz
    fi
  done
fi

# a copy of following control files from your central server
# /var/indimail/control/me
# /var/indimail/control/defaultdomain,
# /var/indimail/control/plusdomain
# so that qmail-inject uses appropriate host names in outgoing mail; and
# this host's name in /var/indimail/control/idhost, so that qmail-inject
# generates Message-ID without any risk of collision
if [ ! -f %{qsysconfdir}/control/idhost ] ; then
  default_domain=$([ -n "$HOSTNAME" ] && echo "$HOSTNAME" || `uname -n`)
  echo $default_domain > %{qsysconfdir}/control/idhost
fi
if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  echo "recreating ld.so cache"
  /sbin/ldconfig
fi
) >> /var/log/%{name}-setup.log

%postun -n indimail-mini
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 1 ] ; then
  (
  if [ -f %{libexecdir}/qupgrade.sh ] ; then
    echo "Running Custom Un-Installation Script for postun upgrade"
    /bin/sh %{libexecdir}/qupgrade.sh postun upgrade %{version} $*
  fi
  ) >> /var/log/%{name}-setup.log
  if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
    echo "recreating ld.so cache"
    /sbin/ldconfig
  fi
  exit 0
fi
(
if [ -x /usr/sbin/alternatives ] ; then
  alternatives_cmd=/usr/sbin/alternatives
elif [ -x /usr/sbin/update-alternatives ] ; then
  alternatives_cmd=/usr/sbin/update-alternatives
else
  alternatives_cmd=""
fi
if [ -n $alternatives_cmd ] ; then
  $alternatives_cmd --remove mta %{_prefix}/bin/sendmail
  $alternatives_cmd --auto mta
  for i in /usr/lib/sendmail /usr/sbin/sendmail %{_sysconfdir}/pam.d/smtp; do
    if [ -f $i.old -o -L $i.old ]; then
      echo "restoring $i"
      %{__mv} $i.old $i
    fi
  done
else
  if [ -f %{_sysconfdir}/init.d/sendmail ] ; then
    if [ -f /sbin/chkconfig ] ; then
      /sbin/chkconfig --add sendmail
      echo "to start sendmail, issue"
      echo "%{_sysconfdir}/init.d/sendmail start"
    fi
  fi
fi
for i in /usr/lib/sendmail /usr/sbin/sendmail %{_sysconfdir}/pam.d/smtp; do
  if [ -f $i.old -o -L $i.old ]; then
    echo "restoring $i"
    %{__mv} $i.old $i
  fi
done
for i in mailq newaliases; do
  if [ -f /usr/share/man/man1/$i.old.1.gz ] ; then
    echo "restoring /usr/share/man/man1/$i.1.gz"
    %{__mv} /usr/share/man/man1/$i.old.1.gz /usr/share/man/man1/$i.1.gz
  fi
done
if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  echo "recreating ld.so cache"
  /sbin/ldconfig
fi
) >> /var/log/%{name}-setup.log

# fix changelog for openSUSE buildservice
%changelog
* Sat Nov 28 2020 12:43:53 +0530 indimail-mta@indimail.org 2.12-1.1%{?dist}
Release 2.12 Start 21/05/2020
- 12/09/2020
01. hier.c: use 0755 for bin and sbin
02. indimail-mta: replaced setup with installer which uses text files for installation
03. indimail-mta.spec: fixed AutoReq
- 13/09/2020
04. indimail-mta.spec: updated compiler flags for ucspi-tcp
05. ucspi-tcp: replaced setup with installer which uses text files for installation
06. ucspi-tcp: updated compiler switches
07. instcheck.c: skip chmod if mode is -1
08. hier.c: leave owner, group, permissions alone as they are owned by
    indimail-mta package
09. installer.c: sync permissions with indimail-mta.spec file
- 14/09/2020
10. fixed linkat(), unlinkat(), renameat() calls
- 15/09/2020
11. leapsecs.txt: added date 2016-12-31
12. moved to libqmail:  mess822.h, mess822_addr.c, mess822_date.c,
    mess822_fold.c, mess822_line.c, mess822_ok.c, mess822_quote.c,
    mess822_token.c, mess822_when.c, mess822.3 mess822_addr.3,
    mess822_date.3, mess822_fold.3, mess822_quote.3, mess822_token.3,
    mess822_when.3
13. moved to libqmail: commands.c, commands.h, rewritehost.c, rewritehost.h,
    rewritehost.3
14. smtpd.c, ofmpid.c: variable ctl_maxcmdlen moved to libqmail
15. moved to libqmail: sconfig.c, sconfig.h
16. qmail-send.c, qmail-todo.c: use control files conf-fsync, conf-syncdir
    to turn on fsync, bsd style syncdir semantics
17. qmail-send.c, qmail-todo.c: set / unset USE_FSYNC, USE_SYNCDIR env
    variables
18. qmail-queue.c, qmail-local.c: changed default value of use_fsync,
    use_syncdir to -1
- 16/09/2020
19. indimail-mta, ucspi-tcp: fixes for FreeBSD
- 17/09/2020
20. svctool, create_services, update_tmprsadh, config-fast: fixes for FreeBSD
- 19/09/2020
21. portable Makefile for Linux, FreeBSD, OSX
- 20/09/2020
22. tcpserver.c: open ipv4, ipv6 sockets on FreeBSD and use select before accept()
23. cronlist.q: skip run-cleanq if qscanq service is not installed
- 22/09/2020
24. create_service: fixed certificate path for poppass, indisrvr service
25. use conf-cc-SYSTEM, conf-ld-SYSTEM for system specific CFLAGS, LDFLAGS
- 24/09/2020
26. Makefile - indimail-mta, ucspi-tcp: split into variables, main Makefile and
    system specific Makefile. New script qmake to do the build
- 25/09/2020
27. syncdir.c: FreeBSD port (use sys/syscall.h)
28. svctool: use --defaults-file=indimail.cnf for shutdown script to avoid
    issues on FreeBSD
29. removed libwatch service
30. run svctool --fixsharedlibs during MySQL startup
31. DIRS: use relative links in /var/indimail
- 26/09/2020
32. svctool: allow setting of MySQL indimail, admin password, indimail UNIX password by
    setting MYSQL_PASS, PRIV_PASS, ADMIN_PASS in env
- 27/09/2020
33. svctool, envmigrate: fixed handling of failure in imap/pop3 service
    creation
34. indimail-mta.spec: rpmlint fixes for danglin-relative-symlinks
35. svctool: make inlookup,pwdlookup service wait for 30 seconds since MySQL services
    comes up
36. svctool: replace /bin/false with /usr/bin/false on FreeBSD
37. sys-checkpwd.c: restore '@' sign in username for authmodules in the chain
38. sys-checkpwd.c: skip stripping of domain if STRIP_DOMAIN env variable is
    not set
- 28/09/2020
39. Makefile: fix perl path in perl scripts
40. removed unused programs - qmail-lagcheck, qmail-lint, elq, pinq, qail
41. added debug statments in sys-checkpwd
42. svctool: added all available authmodules as IMAPMODULES
- 30/09/2020
43. syncdir.c, syncdir.h, qmail-local.c, qmail-queue.c, qmail-send.c,
    qmail-todo.c: Darwin port for syncdir
44. domainkeys.c: define memcpy, strcasecmp, strncasecmp only if not defined
- 02/10/2020
45. installer.c: set permissions for directory only if it is a new directory
46. svctool: updated macOSuseradd, macOSgroupadd
- 03/10/2020
47. svctool: --fixedharedlibs for Darwin
48. svctool: use /bin/echo -n instead of builtin echo -n (which doesn''t work on Darwin)
49. svctool: create /var/run/mysqld for Darwin when creating mysqldb
50. svctool: use openssl passwd -6 (sha512) missing on darwin use openssl passwd -1 (md5)
51. svctool: use LC_ALL=C for tr command on Darwin
52. svctool: check for mysqld in mysqlprefix/bin for Darwin
53. svctool: updated macOSuseradd, macOSgroupadd functiona for Darwin
54. svctool: fixed date command for getting time in seconds for Darwin/FreeBSD
- 04/10/2020
55. create /service link in /etc/synthetic.conf for Darwin
    create /var/indimail/inquery directory
    svctool: fixed users getting added multiple times to com.apple.loginwindow
    HiddenUsersList
- 05/10/2020
56. installer new features, 1. uninstall option (-u, -i), 2. create devices,
3. create fifo
57. Makefile: Added uninstall target
58. Added comments in installer input files
59. svctool: remove indimail, indimail-mta users from HiddenUsersList for
    Darwin
60. Makefile: run instcheck to set permissions on make install.
- 06/10/2020
61. indimail-mta: Makefile: replaced g++ with c++ for portability
62. indimail-mta, ucspi-tcp: fixed uninstall target
63. installer.c: fixed setting of symbolic links
64. svctool -freebsd: fix for libmysqlclient on freebsd.
65. qmail-local.c: fixed bug with loopcounter in qmail-local.c - initialized
    maxdeliveredto
- 08/10/2020
66. ucspi-tcp/ip6_fmt.c: Fixed bug - Erwin Hoffman
    -09/10/2020
67. qlocal_upgrade.sh: migrate /service to libexecdir
- 10/10/2020
68. smtpd.c: auth functions made static
69. qmail-remote.c: digest_md5() renamed to qr_digest_md5() to avoid clash
70. removed functions duplicated in libqmail
- 12/10/2020
71. added debuginfo package
- 17/10/2020
72. postinst: fixed overwriting of QMAILLOCAL, QMAILREMOTE by service creation
    for odmr port (added --skipsend)
73. qmail-rspawn.c: fixed "Unable to run qmail-remote" when QMAILREMOTE
    variable was unset
74. svctool: fixed "Unable to run qmail-remote" when QMAILREMOTE variable
    wasn't set
75. svctool: use mkfifo -m to create qmail-logfifo with 666 perms
- 18/10/2020
76. svctool: added default-authentication-plugin=mysql_native_password as a comment
77. qcount_dir.c: replaced alloc_re() with alloc()
- 19/10/2020
78. controlfiles.q: added control file servicedir.conf
79. conf-queue: added documenation
- 20/10/2020
80. removed chrpath.
81. removed ucspi-tcp, daemontools
- 22/10/2020
82. upgrade: shutdown indimail-mta services instead of entire svscan service
- 01/11/2020
83. svctool: added display for enabling/disabling auto refresh settings for
    service
84. spawn-filter.c: unset FILTERARGS, SPAMFILTER, QMAILLOCAL, QMAILREMOTE
    before calling qmail-local, qmail-remote
- 09/11/2020
85. svctool: inlookup, pwdlookup service - removed svwait program. use waitfor service instead
- 14/11/2020
86. indimail-mta.spec: enable openSUSE permissions
- 17/11/2020
87. qmail-daned.c: set default value for timeoutssl to prevent select() doing
    poll
88. sslerator: added tls/ssl protocol wrapper from indimail-virtudomains
    package
- 18/11/2020
89. svctool: make authpam the last module as it cannot execute additional
    modules
90. preinst/postinst: modified service shutdown/startup during upgrade by
    using /run, /var/run
- 26/11/2020
91. smtpd.c: refactored batv code
- 28/11/2020
92. 822field.c, 822fields.c: +HeaderName feature by Erwin Hoffman: display all
    headers which have HeaderName as the initial text
